package org.zheng.demo;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertThrows;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.zheng.demo.service.MyService;

@SpringBootTest
public class MyAspectIntegrationTest {

	@Autowired
	MyService myService;

	@Test
	void test_aop_before_after() {
		myService.myMethod();
	}

	@Test
	void test_aop_afterReturning() {
		String ret = myService.returnData("123");
		assertEquals("123", ret);
	}

	@Test
	void test_aop_afterThrowing() {
		NumberFormatException ex = assertThrows(NumberFormatException.class, () -> {
			myService.returnData("mary");
		});

		assertEquals("For input string: \"mary\"", ex.getMessage());
	}
}
