package org.zheng.demo;

import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.times;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.reflect.MethodSignature;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.jupiter.MockitoExtension;
import org.zheng.demo.aop.MyAopExample;

@ExtendWith(MockitoExtension.class)
public class MyAspectUnitTest {
	@Mock
	private ProceedingJoinPoint proceedingJoinPoint;

	@InjectMocks
	private MyAopExample testAspect;

	@Test
	public void testLogExecutionTime() throws Throwable {
		// Given
		when(proceedingJoinPoint.proceed()).thenAnswer(invocation -> {
			Thread.sleep(100); // Simulate method execution time
			return null;
		});

		when(proceedingJoinPoint.getSignature()).thenReturn(mock(MethodSignature.class));

		// When
		testAspect.logExecutionTime(proceedingJoinPoint);

		// Then
		verify(proceedingJoinPoint, times(1)).proceed();
		// Additional assertions can be made to check the log output if needed
	}
}
